<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: cr_alfa_extension_15082014.xml */
/* Generado: 2014-08-26 22:08:10 */

/* Mantenimiento de los registros de la tabla cr_tipo_file */
abstract class BaseCr_tipo_fileDP extends Cr_tipo_fileBV
{
    /* Constructor ( Establece los valores desde un objeto Cr_tipo_fileBN ) */
    public function __construct( Cr_tipo_fileBN $o_Cr_tipo_fileBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_Cr_tipo_fileBN ) )
        {
            $this->setByBN( $o_Cr_tipo_fileBN );
        }
    }

    /* Establece los valores desde un objeto Cr_tipo_fileBN */
    public function setByBN( Cr_tipo_fileBN $o_Cr_tipo_fileBN )
    {
        if ( !is_null( $o_Cr_tipo_fileBN->getIdtipofile() ) )
        {
            $this->setIdtipofile( $o_Cr_tipo_fileBN->getIdtipofile() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_Cr_tipo_fileBN->getDescripcion() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getEstado() ) )
        {
            $this->setEstado( $o_Cr_tipo_fileBN->getEstado() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getView() ) )
        {
            $this->setView( $o_Cr_tipo_fileBN->getView() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_Cr_tipo_fileBN->getFechaRegistro() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_Cr_tipo_fileBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getEliminado() ) )
        {
            $this->setEliminado( $o_Cr_tipo_fileBN->getEliminado() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getFechaEliminado() ) )
        {
            $this->setFechaEliminado( $o_Cr_tipo_fileBN->getFechaEliminado() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getUsuarioEliminado() ) )
        {
            $this->setUsuarioEliminado( $o_Cr_tipo_fileBN->getUsuarioEliminado() );
        }
        if ( !is_null( $o_Cr_tipo_fileBN->getSqlDes() ) )
        {
            $this->setSqlDes( $o_Cr_tipo_fileBN->getSqlDes() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_cr_tipo_fileFN = new Cr_tipo_fileFN();
        $o_cr_tipo_fileBN = $o_cr_tipo_fileFN->selectByPk( $this->getIdtipofile() );
        if ( is_null( $o_cr_tipo_fileBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO cr_tipo_file ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdtipofile() ) )
            {
                $s_SQLQuery1 .= $s_Separator."idtipofile";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdtipofile()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getView() ) )
            {
                $s_SQLQuery1 .= $s_Separator."View";
                $s_SQLQuery2 .= $s_Separator."'".$this->getView()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Eliminado";
                $s_SQLQuery2 .= $s_Separator."".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSqlDes() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SqlDes";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSqlDes()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = $o_cr_tipo_fileFN->getConnect();
            $o_Result = mysql_query( $s_SQLQuery, $o_Resource );
            if ( $o_Result === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        $o_cr_tipo_fileFN = new Cr_tipo_fileFN();
        $o_cr_tipo_fileBN = $o_cr_tipo_fileFN->selectByPk( $this->getIdtipofile() );
        if ( !is_null( $o_cr_tipo_fileBN ) )
        {
            $s_SQLQuery = "UPDATE cr_tipo_file SET ";
            $s_Separator = "";
            if ( !is_null( $this->getDescripcion() ) && $this->getDescripcion() !== $o_cr_tipo_fileBN->getDescripcion() )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) && $this->getEstado() !== $o_cr_tipo_fileBN->getEstado() )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getView() ) && $this->getView() !== $o_cr_tipo_fileBN->getView() )
            {
                $s_SQLQuery .= $s_Separator."View = '".$this->getView()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) && $this->getFechaRegistro() !== $o_cr_tipo_fileBN->getFechaRegistro() )
            {
                $s_SQLQuery .= $s_Separator."FechaRegistro = '".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) && $this->getUsuarioRegistro() !== $o_cr_tipo_fileBN->getUsuarioRegistro() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioRegistro = '".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) && $this->getEliminado() !== $o_cr_tipo_fileBN->getEliminado() )
            {
                $s_SQLQuery .= $s_Separator."Eliminado = ".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) && $this->getFechaEliminado() !== $o_cr_tipo_fileBN->getFechaEliminado() )
            {
                $s_SQLQuery .= $s_Separator."FechaEliminado = '".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) && $this->getUsuarioEliminado() !== $o_cr_tipo_fileBN->getUsuarioEliminado() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioEliminado = '".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSqlDes() ) && $this->getSqlDes() !== $o_cr_tipo_fileBN->getSqlDes() )
            {
                $s_SQLQuery .= $s_Separator."SqlDes = '".$this->getSqlDes()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  idtipofile = ".$this->getIdtipofile().";";
            $o_Resource = $o_cr_tipo_fileFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $o_cr_tipo_fileFN = new Cr_tipo_fileFN();
        $o_cr_tipo_fileBN = $o_cr_tipo_fileFN->selectByPk( $this->getIdtipofile() );
        if ( !is_null( $o_cr_tipo_fileBN ) )
        {
            $s_SQLQuery = "DELETE FROM cr_tipo_file WHERE  idtipofile = ".$this->getIdtipofile().";";
            $o_Resource = $o_cr_tipo_fileFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Selecciona un registro por la llave primaria */
    public static function selectByPk( $i_Idtipofile )
    {
        $o_cr_tipo_fileFN = new Cr_tipo_fileFN();
        if ( $o_cr_tipo_fileBN = $o_cr_tipo_fileFN->selectByPK( $i_Idtipofile ) )
        {
            $o_cr_tipo_fileDP = new cr_tipo_fileDP();
            $o_cr_tipo_fileDP->setIdtipofile( $o_cr_tipo_fileBN->getIdtipofile(), false );
            $o_cr_tipo_fileDP->setDescripcion( $o_cr_tipo_fileBN->getDescripcion(), false );
            $o_cr_tipo_fileDP->setEstado( $o_cr_tipo_fileBN->getEstado(), false );
            $o_cr_tipo_fileDP->setView( $o_cr_tipo_fileBN->getView(), false );
            $o_cr_tipo_fileDP->setFechaRegistro( $o_cr_tipo_fileBN->getFechaRegistro(), false );
            $o_cr_tipo_fileDP->setUsuarioRegistro( $o_cr_tipo_fileBN->getUsuarioRegistro(), false );
            $o_cr_tipo_fileDP->setEliminado( $o_cr_tipo_fileBN->getEliminado(), false );
            $o_cr_tipo_fileDP->setFechaEliminado( $o_cr_tipo_fileBN->getFechaEliminado(), false );
            $o_cr_tipo_fileDP->setUsuarioEliminado( $o_cr_tipo_fileBN->getUsuarioEliminado(), false );
            $o_cr_tipo_fileDP->setSqlDes( $o_cr_tipo_fileBN->getSqlDes(), false );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return $o_cr_tipo_fileDP;
    }
}
?>